unit base;

(***************************************)
(* Copyright (C) 2003, SHIRAISHI Kazuo *)
(***************************************)



interface
uses  QStdCtrls,QComCtrls,IniFiles,SysUtils,Classes, QGraphics,QMenus, Qt,
      sconsts;
const
   MinInt=-maxint-1;
type
   tpPrecision=(PrecisionNormal,PrecisionHigh,PrecisionNative,PrecisionComplex,PrecisionRational);
const
   PrecisionText:array[tpPrecision]of AnsiString=(s_decimal,s_1000digits,s_Binary,s_complex,s_rational);
   PrecisionLiteral:array[tpPrecision]of AnsiString=('DECIMAL','DECIMAL_HIGH','NATIVE','COMPLEX','RATIONAL');
type
   IOOption=(ioReadWrite,ioCharacterByte,ioSkipRest,ioWhenInside,ioClear,ioNoWait);
   IOOptions=set of IOOption;
    tpRecordSetter=(rsNone,rsBEGIN,rsEND,rsNEXT,rsSAME);
    AccessMode=(amOUTIN,amINPUT,amOUTPUT);
    RecordType=(rcDISPLAY,rcINTERNAL);
    OrganizationType=(orgSEQ,orgSTREAM);
const
    AccessModeLiteral:array[AccessMode]of AnsiString=('OUTIN','INPUT','OUTPUT');
    RecordTypeLiteral:array[RecordType] of ansistring =('DISPLAY','INTERNAL');
    OrganizationTypeLiteral:array[OrganizationType] of Ansistring=('SEQUENTIAL','STREAM');
    YesNoLiteral:array[false..true]of AnsiString=('NO','YES');
type
   array3 = array[1..3] of longint;
const
  MaxListSize = Maxint div 16;


var
  paramIndex:integer;      //ޥɥѥ᡼index¹ϥץե̾ΰ֤򤵤

type
    EExtype=class(Exception);

var
   extype :integer      =0;
var
   pass     :integer    =0;
   exline   :integer    =0;
   expos    :integer    =0;
   exinsertcount:integer=0;
   helpContext:integer  =0;

const
    bkCancel=0;
    bkStep=1;
    bkContinue=2;
var
    bkDirective:integer=bkCancel;
var
   GraphMode:boolean=false;
   TextMode:boolean=false;
   KeepGraphic:boolean=false;
   KeepText:boolean=false;
   UseCharInput:boolean=false;
   InitialPrecisionMode0:tpPrecision=PrecisionNormal;
   InitialPrecisionMode:tpPrecision=PrecisionNormal;
   PrecisionMode :tpPrecision=PrecisionNormal;
   initialOptionBase:byte=1;
   initialAngleDegrees:boolean=false;
   initialCharacterByte0:boolean=false;
   initialCharacterByte:boolean=false;
   JISFormat:boolean=false;
   JISSetWindow:boolean=false;
   JISDim:boolean=false;
   JISDef:boolean=false;
   ForNextBroadOwn:boolean=false;
   ForceFunctionDeclare:boolean=false;
   UseTranscendentalFunction:boolean=false;
   signiwidthMore:boolean=false;
   MinimalBasic:boolean=false;
   PermitMicrosoft:boolean=false;
   InsertDIMst:boolean=false;
   OptionExplicit:boolean=false;
   AutoIndent:boolean=true;
const
   ac_let=0;
   ac_input=1;
   ac_using=2;
   ac_next=3;
   ac_string=4;
   ac_remark=5;
   ac_exp=6;
   ac_while=7;
   ac_multi=8;
   ac_end=9;
var
   AutoCorrect:array[0..ac_end]of boolean=(true,true,true,true,true,true,false,false,false,false);
var
   shift_F5:string='LET ';
   shift_F6:string='PRINT ';
   shift_F7:string='OPTION ANGLE DEGREES';
   shift_F8:string='';
var
  ExecutingNow:boolean=false;
var
  NoInitialize:boolean=false;
  NoRun:boolean=false;
  OpenAndRun:boolean=false;
  NoBackUp:boolean=true;           //2007/8/27

var      initialESP:cardinal;
function stacksize1:integer;assembler;
var      StackLimit:integer=$100000;


procedure setexception(t:integer);
procedure setexceptionwith(const s:string; t:integer);

const
      outofmemory=-100;
      StackOverflow=-101;
      VirtualStackOverflow=-102;
      ArraySizeOverflow=-103;
      TextOverFlow=-108;
      SystemErr=-109;

{*****************}
{Utility functions}
{*****************}

procedure  upper(var s:string);
procedure  lower(var s:string);

function imod(a,b:integer):integer;
function Spaces(n:integer):ansistring;
procedure SelectLine(memo:Tmemo;i:integer);


procedure Idle;
procedure IdleImmediately;

//ץåȥ
const
   maxnumber1:array[0..4]of word=($ffff,$ffff,$ffff,$ffff,$7ffe);
var
   maxnumber:extended absolute maxnumber1;
const
   maxnumber2:array[0..3]of word=($ffff,$ffff,$ffff,$7fef);
var
   maxnumberDouble:double absolute maxnumber2;


var
   HideSyntaxMenu:boolean=false;
   IniFileReadOnly:boolean=false;

function max(a,b:integer):integer;
function min(a,b:integer):integer;

function IniFileName:string;
procedure InitializeEnv;

type
   TMyIniFile=class(TObject)
     Ini:TIniFile;
     section:string;
     readOnly:boolean;
     constructor create(const section1:string);
     destructor  destroy; override;
     function ReadInteger (const Ident: string; Default: integer): integer;
     function ReadString (const Ident: string; const Default: string): string;
     function ReadBool (const Ident: string; Default: Boolean): Boolean;
     procedure   WriteInteger(const Ident: string; Value: integer);
     procedure   Writestring(const Ident: string; const Value:string);
     procedure   WriteBool(const Ident: string; Value: Boolean);
     procedure   RestoreFont(font: TFont);
     procedure   StoreFont(font: TFont);
   end;

type
   TStatusMes=class(TStringList)
       function add(const s:string):integer;override;
       function murge:string;
       function murgeWithOR:string;
       procedure insert(const s:string);
   end;
var
   statusmes:TStatusmes;

 {***}
 {FPU}
 {***}
var   controlword:word= $1372;
var   RoundMost :WORD = $1372; //ᤤͤ˴ݤ
var   RoundNins :WORD = $1772; //ݡڤΤ
var   RoundPlus :WORD = $1B72; //ܡڤ夲
var   RoundZero :WORD = $1F72; //ͤ˴ݤ

const
  CharNameTBL1:array[0..39] of string[3] =
           ('NUL','SOH','STX','ETX','EOT','ENQ','ACK','BEL','BS','HT',
            'LF' ,'VT' ,'FF' ,'CR' ,'SO' ,'SI' ,'DLE','DC1','DC2','DC3',
            'DC4','NAK','SYN','ETB','CAN','EM' ,'SUB','ESC','FS' ,'GS' ,
            'RS' ,'US' ,'SP' ,'UND','GRA','LBR','VLN','RBR','TIL','DEL');
  CharNameTBL2:array[0..39] of byte =
           (  0, 1, 2, 3, 4, 5, 6, 7, 8, 9,
             10,11,12,13,14,15,16,17,18,19,
             20,21,22,23,24,25,26,27,28,29,
             30,31,32,95,96,123,124,125,126,127);


 {****}
 {FONT}
 {****}

var
  EditorFont:TFont;
  PrinterFont:TFont;

procedure SetFontSub(font:TFont; MainMenu:TMainMenu);

{++++++++++++}
implementation
{++++++++++++}

uses  Types,Qforms,QControls,
      myutils;

procedure  upper(var s:string);
var
     i:integer;
begin
     i:=0;
     while i<length(s) do
        begin
            inc(i);
            if s[i] in ['a'..'z'] then
                   s[i]:=chr(ord(s[i])-32)
            else
                   if IsDBCSLeadByte(byte(s[i])) then inc(i);
        end;
end;

procedure  lower(var s:string);
var
     i:integer;
begin
     i:=0;
     while i<length(s) do
        begin
            inc(i);
            if s[i] in ['A'..'Z'] then
                   s[i]:=chr(ord(s[i])+32)
            else
                   if IsDBCSLeadByte(byte(s[i])) then inc(i);
        end;
end;


function max(a,b:integer):integer;
begin
  if a>b then
     max:=a
  else
     max:=b
end;

function min(a,b:integer):integer;
begin
  if a>b then
     min:=b
  else
     min:=a
end;

function stacksize1:integer;assembler;
asm
   mov    eax,initialESP
   sub    eax,esp
end;


{**************}
{error handling}
{**************}

procedure setexception(t:integer);
begin
  setexceptionwith('',t)
end;

procedure setexceptionwith(const s:string; t:integer);
begin
    extype :=t;
    statusmes.add(s);
    raise EExtype.create('');
end;


function imod(a,b:integer):integer;
var
n:integer;
begin
   if a>=0 then
      imod:=a mod b
   else
      begin
         n:=a mod b;
         if n<>0 then inc(n,b);
         imod:=n
      end;
end;

function Spaces(n:integer):ansistring;
var
  i:integer;
  s:ansistring;
begin
  s:='';
  for i:=1 to n do s:=s+' ';
  Spaces:=s
end;

procedure SelectLine(memo:Tmemo;i:integer);
var
  CPos:TCaretPos;
  ws:Widestring;
begin
  Cpos.Line:=i;
  Cpos.Col:=0;
   with memo do
      begin
         (memo.owner as TForm).BringToFront;
         //SelStart:=SendMessage(Handle,EM_LINEINDEX,i,0);
         caretPos:=Cpos;
         ws:=Lines[i];
         SelLength:=Length(ws);
      end;
end;

{********}
{INI File}
{********}

function IniFileName:string;
begin
{$IFDEF LINUX}
   result:=GetEnvironmentVariable('HOME') + '/.basic.ini'
{$ELSE}
   result:= ChangeFileExt(Application.ExeName,'.ini')
{$ENDIF}
end;


var
   UseReg:boolean=false;


constructor TMyIniFile.create(const section1:string);
begin
   inherited create;
   Ini:=TIniFile.create(iniFileName);
   section:=section1;
   ReadOnly:=NoInitialize or IniFileReadOnly;
end;

destructor TMyIniFile.destroy;
begin
   if Ini<>nil then ini.free;
   inherited destroy;
end;


function TMyIniFile.ReadInteger (const Ident: string; Default: integer): integer;
begin
  if ini<>nil then
    result:=ini.ReadInteger(section,ident,default)
end;

function TMyIniFile.ReadString (const Ident: string; const Default: string): string;
begin
   if ini<>nil then
    result:=ini.ReadString(section,ident,default)
end;

function TMyIniFile.ReadBool (const Ident: string; Default: Boolean): Boolean;
begin
  if ini<>nil then
    result:=ini.ReadBool(section,ident,default)
end;

procedure   TMyIniFile.WriteInteger(const Ident: string; Value: integer);
begin
   if not readonly then
     if ini<>nil then
      try
       ini.WriteInteger(section,ident,value)
      except
      end
end;

procedure   TMyIniFile.Writestring(const Ident: string; const Value:string);
begin
   if not readonly then
     if ini<>nil then
       try
        ini.WriteString(section,ident,value)
       except
       end
end;

procedure   TMyIniFile.WriteBool(const Ident: string; Value: Boolean);
begin
   if not readonly then
     if ini<>nil then
      try
       ini.WriteBool(section,ident,value)
      except
      end 
end;

procedure   TMyIniFile.RestoreFont(font: TFont);
begin
 with font do
   begin
      Charset:=TFontCharset(ReadInteger('FontCharset',Ord(charset)));
      //Height:=ReadInteger('FontHeight',Height);
      Name:=ReadString('FontName',Name);
      Size:=ReadInteger('FontSize',Size);
      Pitch:=TFontPitch(ReadInteger('FontPitch',Ord(Pitch)));
      Weight:=ReadInteger('FontWeight',Weight);
   end;
end;

procedure   TMyIniFile.StoreFont(font: TFont);
begin
  with font do
   begin
      WriteInteger('FontCharset',Ord(charset));
      //WriteInteger('FontHeight',Height);
      WriteString('FontName',Name);
      WriteInteger('FontSize',Size);
      WriteInteger('FontPitch',Ord(Pitch));
      WriteInteger('FontWeight',Weight);
   end;
end;


procedure ReadIniFile;
var
   IniFile:TMyIniFile;
begin
    IniFile:=TMyIniFile.create('Frame');
    with IniFile do
       begin
         InitialOptionBase:=ReadInteger('OptionBase',InitialOptionbase);
         InitialCharacterByte0:=ReadBool('CharacterByte', InitialCharacterByte0);
         JISFormat:=ReadBool('JISFormat',JISFormat);
         JISSetWindow:=ReadBool('JISSetWindow',JISSetWindow);
         JISDim:=ReadBool('JISDim',JISDim);
         JISDef:=ReadBool('JISDef',JISDef);
         ForNextBroadOwn:=ReadBool('ForNextBroadOwn',ForNextBroadOwn);
         ForceFunctionDeclare:=ReadBool('ForceFunctionDeclare',ForceFunctionDeclare);
         AutoIndent:=ReadBool('AutoIndent',AutoIndent);
         PermitMicrosoft:=ReadBool('Microsoft',PermitMicrosoft);
         MinimalBasic:=ReadBool('MinimalBasic',MinimalBasic);
         OptionExplicit:=ReadBool('OptionExplicit',OptionExplicit);
         IniFileReadOnly:=ReadBool('IniFileReadOnly',IniFileReadOnly);
         InsertDIMst:=ReadBool('InsertDIM',InsertDIMst);
         NoRun:=ReadBool('NoRun',NoRun);
         shift_F5:=ReadString('Shift_F5',Shift_F5);
         shift_F6:=ReadString('Shift_F6',Shift_F6);
         shift_F7:=ReadString('Shift_F7',Shift_F7);
         shift_F8:=ReadString('Shift_F8',Shift_F8);
       end;
     IniFile.free;
end;

procedure WriteIniFile;
var
   IniFile:TMyIniFile;
begin
      IniFile:=TMyIniFile.create('Frame');
      with IniFile do
      begin
          WriteBool('AutoIndent',AutoIndent);
          WriteBool('JISFormat',JISFormat);
          WriteBool('JISSetWindow',JISSetWindow);
          WriteBool('JISDim',JISDim);
          WriteBool('JISDef',JISDef);
          WriteBool('ForNextBroadOwn',ForNextBroadOwn);
          WriteBool('ForceFunctionDeclare',ForceFunctionDeclare);
          WriteBool('OptionExplicit',OptionExplicit);
          WriteString('Shift_F5',Shift_F5);
          WriteString('Shift_F6',Shift_F6);
          WriteString('Shift_F7',Shift_F7);
          WriteString('Shift_F8',Shift_F8);
      end;
      IniFile.free;
end;

procedure InitializeEnv;
begin
  if Application.MessageBox(s_InitEnv,AppTitle,[sMBOK,smbCANCEL])=smbOk then
  begin
    IniFileReadOnly:=true;
    SysUtils.DeleteFile(IniFileName);
  end;
end;



{**********}
{TStatusMes}
{**********}

function TStatusMes.add(const s:string):integer;
begin
   if indexof(s)<0 then
      result := inherited add(s)
   else
      result:=-1    ;
end;


function TStatusMes.murge:string;
var
   i:integer;
begin
   if count=0 then
      result:=''
   else
   begin
     result:=strings[0];
     for i:=1 to count-1 do
      result:=result +EOL+ strings[i];
   end;
end;

function TStatusMes.murgeWithOR:string;
var
   i:integer;
begin
   if count=0 then
      result:='Syntax Error'
   else
   begin
     result:=strings[0];
     for i:=1 to count-1 do
      result:=result +s_or + strings[i];
   end;
end;


procedure TStatusMes.insert(const s:string);
begin
   if count=0 then
      add(s)
   else
      strings[0]:=s +EOL + strings[0]
end;



{****}
{Idle}
{****}
var IdleCount:byte=0;

procedure Idle;
begin
  inc(idlecount);
  if idleCount=0 then
     IdleImmediately
end;

procedure IdleImmediately;
begin
      Application.ProcessMessages;
      Set8087CW(controlword);
      idlecount:=0
end;

procedure InitFonts;
begin


  with Application.Font do
    begin
        if c_language='J' then
        begin
            CharSet := fcsSet_Ja;
            Name:= '*';
        end;
        Color := clBlack;
        Pitch:=fpDefault;
        Size := 11;
    end;
  with TMyIniFile.create('ApplicationFont') do
    begin
      RestoreFont(Application.Font);
      free
    end;


  EditorFont:=TFont.create;
  with EditorFont do
    begin
       if c_language='J' then
        begin
           CharSet :=fcsSet_Ja;
           Name :='*';   {'sony-fixed';}
           Height := 16;
        end;
       Color := clBlack;
       Pitch := fpFixed;
    end;
  with TMyIniFile.create('EditorFont') do
       begin
        RestoreFont(EditorFont);
        free
       end;

  PrinterFont:=TFont.create;
  PrinterFont.Assign(Application.Font);
  with TMyIniFile.create('PrinterFont') do
       begin
         RestoreFont(PrinterFont);
         free
       end;
end;

procedure SetFontSub(font:TFont; MainMenu:TMainMenu);
var
   hfont:QFontH;
    i:integer;
begin
   hfont:=font.Handle;
   QWidget_setFont(MainMenu.Handle, hfont);
   for i := 0 to MainMenu.Items.Count-1 do
      QPopupMenu_setFont(MainMenu.Items[i].Handle, hfont);
end;


initialization

  asm
      FSTCW  controlword
  end;
  controlword:=controlword and $F372 or $1332;
  RoundNins:=controlword or $0700; //ݡڤΤ
  RoundPlus:=controlword or $0B00; //ܡڤ夲
  RoundZero:=controlword or $0F00; //ͤ˴ݤ

  paramIndex:=1;
  while (ParamIndex<=ParamCount) and (copy(ParamStr(paramIndex),1,1)='-')  do
       begin
          if ParamStr(paramIndex)='-NI' then NoInitialize:=true;
          if ParamStr(paramIndex)='-OR' then OpenAndRun:=true;
          if ParamStr(paramIndex)='-NR' then NoRun:=true;
          inc(paramIndex);
       end;

  readIniFile;

 if c_Language='E' then
    initialCharacterByte0:=true;

  InitFonts;

  statusmes:=TStatusMes.create;


finalization
  WriteIniFile;
  statusmes.free;

  with TMyIniFile.create('ApplicationFont') do
       begin
         StoreFont(Application.Font);
         free
       end;

   with TMyIniFile.create('EditorFont') do
         begin
             StoreFont(EditorFont);
             free
         end;
   EditorFont.Free;

   with TMyIniFile.create('PrinterFont') do
         begin
             StoreFont(PrinterFont);
             free
         end;
   PrinterFont.Free;



end.
